﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr206_1
{
    // Класс с главным методом: 
    class Program
    {
        // Главный метод (описан с ключевым словом unsafe):
        unsafe static void Main()
        {
            // Объявление целочисленной переменной: 
            int n;
            // Объявление указателя на значение типа int: 
            int* p;
            // Присваивание указателю значения: 
            p = &n;
            // Через указатель присваивается значение переменной:
            *p = 123;
            // Отображение значения переменной:
            Console.WriteLine("Значение переменной n={0}", n);
            Console.WriteLine("Значение выражения *p={0}", *p);
            Console.WriteLine("Адрес переменной n: {0}", (uint)p);
            Console.WriteLine();
            // Объявление указателя на значение типа byte: 
            byte* q;
            // Объявление указателя на значение типа char: 
            char* s;
            // Присваивание указателей и явное приведение типа:
            q = (byte*)p;
            s = (char*)p;
            // Переменной присваивается новое значение: 
            n = 65601;
            // Проверка значений указателей:
            Console.WriteLine("Адрес в указателе p: {0}", (uint)p);
            Console.WriteLine("Адрес в указателе q: {0}", (uint)q);
            Console.WriteLine("Адрес в указателе s: {0}", (uint)s); 
            Console.WriteLine();
            // Отображение значения через указатель:
            Console.WriteLine("Значение типа int: {0}", *p);
            Console.WriteLine("Значение типа byte: {0}", *q);
            Console.WriteLine("Значение типа char: \'{0}\'", *s);
            Console.WriteLine("Значение переменной n={0}", n);
            Console.WriteLine();
            // Присваивание значения через указатель:
            *s = 'F';
            // Проверка значений:
            Console.WriteLine("Значение типа int: {0}", *p);
            Console.WriteLine("Значение типа byte: {0}", *q);
            Console.WriteLine("Значение типа char: \'{0}\'", *s);
            Console.WriteLine("Значение переменной n={0}", n);
            // Задержка:
            Console.ReadLine();
        }
    }
}
